/**************************************************************************************************/

/*
 * File: 
 * Author: Roman Lysecky
 * Date Created: 01 December 2011
 *
 * Description: Creates a random graph adhering to the file format requirements for ECE 275
 *              Assignment 5. NOTE: This does not guarantee the strcuture of file is valid.
 *
 * Copyright: Roman Lysecky
 *
 */

/**************************************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <time.h>

/**************************************************************************************************/

/*
 * WARNING: No comments below. Read at your own peril.
 *
 */

int 
main(int argc, char *argv[]) 
{
    int numVertices, numHubs, numEdges;
    FILE* outFile;
    int i;
    
    srand(time(0));
    
    if( argc != 5 ) {
        printf("Usage: graffinator numVertices numHubs numEdges outFile\n");
        return -1;
    }
    
    if( sscanf(argv[1], "%i", &numVertices) != 1 || numVertices < 2 ) {
        printf("Invalid Num Vertices!\n\n");
        printf("Usage: graffinator numVertices numHubs numEdges outFile\n");
        return -1;    
    }

    if( sscanf(argv[2], "%i", &numHubs) != 1 || numHubs < 2 ) {
        printf("Invalid Num Hubs!\n\n");
        printf("Usage: graffinator numVertices numHubs numEdges outFile\n");
        return -1;    
    }

    if( sscanf(argv[3], "%i", &numEdges) != 1 ) {
        printf("Invalid Num Edges!\n\n");
        printf("Usage: graffinator numVertices numHubs numEdges outFile\n");
        return -1;    
    }

    outFile = fopen(argv[4], "w");
    if( outFile == NULL ) {
        printf("Could not open output file %s!\n", argv[4]);
        return -1;    
    }
    
    fprintf(outFile, "Vertices: %i\n", numVertices);
    
    fprintf(outFile, "Hubs: ");
    for(i=0; i<numHubs; i++) {
        fprintf(outFile, "%i ", rand()%numVertices);
    }
    fprintf(outFile, "\n\n");
    
    fprintf(outFile, "Edges:\n");
    for(i=0; i<numEdges; i++) {
        fprintf(outFile, "%i -> %i : %i\n", rand()%numVertices, rand()%numVertices, rand()%100);
    }
    fprintf(outFile, "\n\n");

    fclose(outFile);
    
    return 0;
}

/**************************************************************************************************/
